import { BunFile } from "bun";
import { Type, command, run, positional, boolean, option, flag } from "cmd-ts";
import { parseProgram, program } from "./parser";

const File: Type<string, BunFile> = {
  from: async (str) => Bun.file(str),
};

const app = command({
  name: "",
  args: {
    lib: flag({ long: "lib", description: "Compile this in library mode (no main function)" }),
    file: positional({ type: File, displayName: "file", description: "Source code" }),
  },
  handler: async ({ lib, file }) => {
    // Read stream to file
    const source = await file.text();

    // Parse source
    const parseResult = parseProgram(source);
    // console.log("tree", parseResult);
  },
});

run(app, Bun.argv.slice(2));
